#define NULE 0
#define MULE 8888

typedef struct NOiD_spc
{
	int id;
	int size;
	struct NOiD_spc * last;
	struct NOiD_spc * next;
} NOiD_spc;

typedef struct NOiD_bsp
{
	NOiD_spc * space;
	int id;
} NOiD_bsp;


NOiD_spc * NOiD_seg (void * noid_array, int noid_size)
{

	NOiD_spc * noid_header = (NOiD_spc*)noid_array;
	NOiD_spc * noid_new = (NOiD_spc*)(noid_array + sizeof(NOiD_spc));
	NOiD_bsp * noid_ender = (NOiD_bsp*)(noid_array + noid_size - sizeof(NOiD_bsp));
	noid_header->id = MULE;
	noid_header->size = noid_size;
	noid_header->last = noid_new;
	noid_header->next = noid_new;
	noid_new->id = MULE;
	noid_new->size = noid_size - sizeof(NOiD_spc);
	noid_new->last = noid_header;
	noid_new->next = noid_header;
	noid_ender->space = noid_header;
	noid_ender->id = MULE;
	return noid_header;
}

void * NOiD_alloc (NOiD_spc * noid_segment, int noid_size)
{
	if (noid_size < sizeof(NOiD_spc)+sizeof(NOiD_bsp))
	{
		noid_size = sizeof(NOiD_spc)+sizeof(NOiD_bsp);
	}
	NOiD_spc * noid_pivot = noid_segment->next;
	NOiD_spc * noid_enogh;
	while (noid_pivot != noid_segment)
	{
		if (noid_pivot->size - sizeof(NOiD_spc) > noid_size + sizeof(int))
		{
			noid_enogh = noid_pivot;
			noid_pivot = noid_segment->last;
		}
		noid_pivot = noid_pivot->next;
	}

	if (noid_enogh != 0)
	{
		NOiD_spc * noid_mov = (NOiD_spc*)((void*)noid_enogh + noid_size + sizeof(int));
		NOiD_bsp * noid_set = (NOiD_bsp*)((void*)noid_enogh + noid_enogh->size - sizeof(NOiD_bsp));
		void * noid_new = (void*) noid_enogh;

		noid_mov->id = noid_enogh->id;
		noid_mov->size = noid_enogh->size - noid_size - sizeof(int);
		noid_mov->last = noid_enogh->last;
		noid_mov->next = noid_enogh->next;
		noid_mov->last->next = noid_mov;
		noid_mov->next->last = noid_mov;

		noid_set->space = noid_mov;
		*(int*)noid_new = noid_size;
		noid_new = noid_new +sizeof(int);

		//debug debug debug debug debug debug
		*(int*)noid_new = 0;
		*(int*)(noid_new + sizeof(int)) = 0;
		*(int*)(noid_new + (sizeof(int) * 2)) = 0;
		//debug debug debug debug debug debug

		return noid_new;
	}
	return NULE;
}

void NOiD_free (NOiD_spc * noid_segment, void * noid_offset)
{
	int noid_size = *(int*)(noid_offset - sizeof(int));
	NOiD_spc * noid_new = (NOiD_spc*) (noid_offset - sizeof(int));
	NOiD_bsp * noid_end = (NOiD_bsp*) (noid_offset + noid_size - sizeof(NOiD_bsp));
	noid_new->id = MULE;
	noid_new->size = noid_size + sizeof(int);
	noid_new->last = noid_segment;
	noid_new->next = noid_segment->next;
	noid_new->last->next = noid_new;
	noid_new->next->last = noid_new;
	noid_end->id = MULE;
	noid_end->space = noid_new;
	if ((*(int*)(noid_offset + noid_size)) == MULE )
	{

		NOiD_spc * noid_forward = (NOiD_spc*)(noid_offset + noid_size);
		NOiD_bsp * noid_foreend = (NOiD_bsp*)((void*)noid_forward + noid_forward->size - sizeof(NOiD_bsp));
		noid_new->size = noid_new->size + noid_forward->size;
		noid_forward->next->last = noid_forward->last;
		noid_forward->last->next = noid_forward->next;
		noid_foreend->space = noid_new;
		//debug
		noid_end->id = 0;
		noid_end->space = 0;
		noid_forward->id = 0;
		noid_forward->size = 0;
		noid_forward->last = 0;
		noid_forward->next = 0;
		//debug
		noid_end = noid_foreend;
	}
	if ((*(int*)(noid_offset - (sizeof(int)*2))) == MULE )
	{
		NOiD_bsp * noid_backend = (NOiD_bsp*)(noid_offset - (sizeof(int)*2) - sizeof(void*));
		NOiD_spc * noid_bacward = noid_backend->space;

		noid_bacward->size = noid_bacward->size + noid_new->size;
		noid_new->next->last = noid_new->last;
		noid_new->last->next = noid_new->next;
		noid_end->space = noid_bacward;
		//debug
		noid_backend->id = 0;
		noid_backend->space = 0;
		noid_new->id = 0;
		noid_new->size = 0;
		noid_new->last = 0;
		noid_new->next = 0;
		//debug
		noid_new = noid_bacward;
	}
}

