

typedef struct NOiD_agenda
{
	void * check;
	void (*func)(void);
	float time;		//intervale
	float wait;		//now + intervale
	float idle;		//before + interval - now;
	struct NOiD_agenda * last;
	struct NOiD_agenda * next;
} NOiD_agenda;


NOiD_agenda * NOiD_schedule (NOiD_agenda * noid_src, void (*noid_func)(void), float noid_timer, void * noid_ptr)
{
	if ((noid_ptr == 0)||(noid_func == 0))
	{	return 0;	}

	NOiD_agenda * noid_rendezvous = (NOiD_agenda *) noid_ptr;
	noid_rendezvous->check = noid_rendezvous;
	noid_rendezvous->func = noid_func;
	noid_rendezvous->time = noid_timer;
	noid_rendezvous->wait = 0;
	noid_rendezvous->idle = 0;

	if (noid_src == 0)
	{
		noid_rendezvous->last = noid_rendezvous;
		noid_rendezvous->next = noid_rendezvous;
	}
	else
	{
		noid_rendezvous->last = noid_src;
		noid_rendezvous->next = noid_src->next;
		noid_rendezvous->last->next = noid_rendezvous;
		noid_rendezvous->next->last = noid_rendezvous;
	}
	return noid_rendezvous;
}

void * NOiD_cancel (NOiD_agenda * noid_rendezvous)
{
	if (noid_rendezvous == 0)
	{	return 0;	}

	noid_rendezvous->last->next = noid_rendezvous->next;
	noid_rendezvous->next->last = noid_rendezvous->last;

	noid_rendezvous->check = 0;
	noid_rendezvous->func = 0;
	noid_rendezvous->time = 0;
	noid_rendezvous->wait = 0;
	noid_rendezvous->idle = 0;
	noid_rendezvous->last = 0;
	noid_rendezvous->next = 0;

	return noid_rendezvous;
}

float NOiD_do (NOiD_agenda * noid_src, float noid_now)
{
	//
	if ((noid_src == 0)||(noid_now == 0))
	{	return 0;	}
	//
	float noid_idle = 40;
	NOiD_agenda * noid_pivot = noid_src->next;
	while (noid_pivot != noid_src)
	{
		if (noid_pivot->wait == 0)
		{
			noid_pivot->wait = noid_now + noid_pivot->time;
			noid_pivot->idle = noid_pivot->wait;
		}
		else
		{
			if (noid_pivot->wait <= noid_now)
			{
				noid_pivot->func();
				noid_pivot->wait = noid_now + noid_pivot->time;
			}
			noid_pivot->idle = noid_pivot->wait - noid_now;
		}
		if (noid_idle > noid_pivot->idle)
		{
			noid_idle = noid_pivot->idle;
		}
		noid_pivot = noid_pivot->next;
	}

	return noid_idle;
}
